#include "BVQXPluginInterfaceExtern.h"
#include "BVQXPluginInterfaceStatic.h"

// general functions
void qxGetVersionOfBrainVoyagerQX(int *major, int *minor, int *subminor)
{
	static_intf::qxGetVersionOfBrainVoyagerQX(major, minor, subminor);
}

void qxGetBrainVoyagerQXPath(char *path)
{
	static_intf::qxGetBrainVoyagerQXPath(path);
}

void qxGetPluginsPath(char *path)
{
	static_intf::qxGetPluginsPath(path);
}

// input / output
void qxShowLogPane()
{
        static_intf::qxShowLogPane();
}

void qxShowLogTab()
{
	static_intf::qxShowLogTab();
}

void qxLogText(const char *txt)
{
	static_intf::qxLogText(txt);
}

void qxMessageBox(const char *msg)
{
	static_intf::qxMessageBox(msg);
}

int qxYesNoMessageBox(const char *prompt)
{
	return static_intf::qxYesNoMessageBox(prompt);
}

int qxGetIntegerInput(const char *prompt, int def, int min, int max)
{
	return static_intf::qxGetIntegerInput(prompt, def, min, max);
}

float qxGetFloatInput(const char *prompt, float def , float min, float max)
{
	return static_intf::qxGetFloatInput(prompt, def, min, max);
}

int qxGetTextInput(const char *prompt, const char *def, char *ret)
{
	return static_intf::qxGetTextInput(prompt, def, ret);
}

int qxGetOpenFileName(const char *instr, const char *folder, const char *type, char *ret)
{
	return static_intf::qxGetOpenFileName(instr, folder, type, ret);
}

int qxGetSaveFileName(const char *instr, const char *folder, const char *type, char *ret)
{
	return static_intf::qxGetSaveFileName(instr, folder, type, ret);
}


// GUI
void qxUpdateActiveWindow()
{
	static_intf::qxUpdateActiveWindow();
}

void qxShowBusyCursor()
{
	static_intf::qxShowBusyCursor();
}

void qxStopBusyCursor()
{
	static_intf::qxStopBusyCursor();
}

// Docs
int qxGetNumberOfDocsInWorkspace()
{
    return static_intf::qxGetNumberOfDocsInWorkspace();
}

int qxGetDocumentType(int id)
{
    return static_intf::qxGetDocumentType(id);
}

char * qxGetDocumentTypeName(int id)
{
    return static_intf::qxGetDocumentTypeName(id);
}

int qxGetIDOfCurrentDocument()
{
    return static_intf::qxGetIDOfCurrentDocument();
}

void qxSetAsCurrentDocument(int doc_n)
{
    static_intf::qxSetAsCurrentDocument(doc_n);
}

int qxCalculateIAMatrix(struct FMR_ScannerPosition_Header *fmr_scp_h, struct VMR_ScannerPosition_Header *vmr_scp_h, struct VMR_PastTransformations_Header *vmr_pt_h, float *f1, float *f2, float *f3, float *f4, float *f5, float *f6, float *f7, float *f8)
{
    return static_intf::qxCalculateIAMatrix(fmr_scp_h, vmr_scp_h, vmr_pt_h, f1, f2, f3, f4, f5, f6, f7, f8);
}

int qxGetTRFParametersFromVolumeToolsDlg(float *f1, float *f2, float *f3, float *f4, float *f5, float *f6, float *f7, float *f8, float *f9)
{
    return static_intf::qxGetTRFParametersFromVolumeToolsDlg(f1, f2, f3, f4, f5, f6, f7, f8, f9);
}


// FMR-STC
int qxGetHeaderOfCurrentFMR(struct FMR_Header *fmr_header)
{
	return static_intf::qxGetHeaderOfCurrentFMR(fmr_header);
}

int qxSetHeaderOfCurrentFMR(struct FMR_Header *fmr_header)
{
	return static_intf::qxSetHeaderOfCurrentFMR(fmr_header);
}

float ** qxGetSTCFloatDataOfCurrentFMR()
{
    return static_intf::qxGetSTCFloatDataOfCurrentFMR();   // NEW in BVQX v2.0 - use to get float ptr to whole STC data
}

short ** qxGetSTCIntDataOfCurrentFMR()
{
    return static_intf::qxGetSTCIntDataOfCurrentFMR();     // NEW in BVQX v2.0 - use to get short int ptr to whole STC data
}

short ** qxGetSTCDataOfCurrentFMR()
{
    return static_intf::qxGetSTCDataOfCurrentFMR();        // deprecated in BVQX 2.0 -> use new fns for int or float
}

int qxSaveFMR(const char *FMRName)
{
    return static_intf::qxSaveFMR(FMRName);
}

int qxSaveFMRAndSTC(const char *FMRName, const char *STCPrefix)
{
    return static_intf::qxSaveFMRAndSTC(FMRName, STCPrefix);
}

unsigned int qxGetScannerPositionHeaderOfCurrentFMR(struct FMR_ScannerPosition_Header *fmr_h)
{
    return static_intf::qxGetScannerPositionHeaderOfCurrentFMR(fmr_h);
}

unsigned int qxSetScannerPositionHeaderOfCurrentFMR(struct FMR_ScannerPosition_Header *fmr_scp_h)
{
    return static_intf::qxSetScannerPositionHeaderOfCurrentFMR(fmr_scp_h);
}


// DMR-DWI
//
int qxGetHeaderOfCurrentDMR(struct DMR_Header *dmr_header)
{
	return static_intf::qxGetHeaderOfCurrentDMR(dmr_header);
}

int qxSetHeaderOfCurrentDMR(struct DMR_Header *dmr_header)
{
	return static_intf::qxSetHeaderOfCurrentDMR(dmr_header);
}

float ** qxGetDWIFloatDataOfCurrentDMR()
{
    return static_intf::qxGetDWIFloatDataOfCurrentDMR();   // NEW in BVQX v2.0 - use to get float ptr to whole STC data
}

short ** qxGetDWIIntDataOfCurrentDMR()
{
    return static_intf::qxGetDWIIntDataOfCurrentDMR();       // NEW in BVQX v2.0 - use to get short int ptr to whole STC data
}

short **qxGetDWIDataOfCurrentDMR()
{
    return static_intf::qxGetDWIDataOfCurrentDMR();        // deprecated in BVQX 2.0 -> use new fns for int or float
}

int qxConvertDWIFormatOfCurrentDMR(int NewStorageFormat, int OnlyInMemory)
{
	return static_intf::qxConvertDWIFormatOfCurrentDMR(NewStorageFormat, OnlyInMemory);
}

int qxSaveDMR(const char *DMRName)
{
	return static_intf::qxSaveDMR(DMRName);
}

int qxSaveDMRAndDWI(const char *DMRName, const char *DWIPrefix)
{
	return static_intf::qxSaveDMRAndDWI(DMRName, DWIPrefix);
}


// VMR
unsigned char * qxGetCurrentVMR(int *DimX, int *DimY, int *DimZ)
{
	return static_intf::qxGetCurrentVMR(DimX, DimY, DimZ);
}

int qxGetMainHeaderOfCurrentVMR(struct VMR_Header *vmr_header)
{
	return static_intf::qxGetMainHeaderOfCurrentVMR(vmr_header);
}

int qxSetMainHeaderOfCurrentVMR(struct VMR_Header *vmr_header)
{
	return static_intf::qxSetMainHeaderOfCurrentVMR(vmr_header);
}

int qxGetScannerPositionHeaderOfCurrentVMR(struct VMR_ScannerPosition_Header *vmr_position_header)
{
	return static_intf::qxGetScannerPositionHeaderOfCurrentVMR(vmr_position_header);
}

int qxSetScannerPositionHeaderOfCurrentVMR(struct VMR_ScannerPosition_Header *vmr_position_header)
{
	return static_intf::qxSetScannerPositionHeaderOfCurrentVMR(vmr_position_header);
}

int qxGetPastTransformationsHeaderOfCurrentVMR(struct VMR_PastTransformations_Header *vmr_pasttransformations_header)
{
	return static_intf::qxGetPastTransformationsHeaderOfCurrentVMR(vmr_pasttransformations_header);
}

int qxSetPastTransformationsHeaderOfCurrentVMR(struct VMR_PastTransformations_Header *vmr_pasttransformations_header)
{
	return static_intf::qxSetPastTransformationsHeaderOfCurrentVMR(vmr_pasttransformations_header);
}

int qxReframeCurrentVMR(int NewDimX, int NewDimY, int NewDimZ)
{
	return static_intf::qxReframeCurrentVMR(NewDimX, NewDimY, NewDimZ);
}

int qxGetCrossPositionOfCurrentVMR(int *DimX, int *DimY, int *DimZ)
{
	return static_intf::qxGetCrossPositionOfCurrentVMR(DimX, DimY, DimZ);
}


// nrVMP
float **qxGetNRVMPsOfCurrentVMR(struct NR_VMPs_Header *vmps_header)
{
	return static_intf::qxGetNRVMPsOfCurrentVMR(vmps_header);
}

float *qxGetNRVMPOfCurrentVMR(int vmp_i, struct NR_VMP_Header *vmp_header)
{
	return static_intf::qxGetNRVMPOfCurrentVMR(vmp_i, vmp_header);
}

int qxSetNRVMPParametersOfCurrentVMR(int vmp_i, struct NR_VMP_Header *vmp_header)
{
	return static_intf::qxSetNRVMPParametersOfCurrentVMR(vmp_i, vmp_header);
}

int qxLoadNRVMPsToCurrentVMR(const char *VolumeMapsFile)
{
	return static_intf::qxLoadNRVMPsToCurrentVMR(VolumeMapsFile);
}

void qxSaveNRVMPsOfCurrentVMR(const char *VolumeMapsFile)
{
	static_intf::qxSaveNRVMPsOfCurrentVMR(VolumeMapsFile);
}

int qxCreateNRVMPsForCurrentVMR(int n_maps, int n_timepoints, int n_params, struct NR_VMPs_Header *vmps_header)
{
	return static_intf::qxCreateNRVMPsForCurrentVMR(n_maps, n_timepoints, n_params, vmps_header);
}

void qxDeleteNRVMPsOfCurrentVMR()
{
	static_intf::qxDeleteNRVMPsOfCurrentVMR();
}

int qxSetNRVMPsParamsDisplayRange(struct NR_VMPs_Header *vmps_header)
{
	return static_intf::qxSetNRVMPsParamsDisplayRange(vmps_header);
}


// arVMP
float **qxGetARVMPsOfCurrentVMR(struct AR_VMPs_Header *vmps_header)
{
	return static_intf::qxGetARVMPsOfCurrentVMR(vmps_header);
}

float *qxGetARVMPOfCurrentVMR(int vmp_i, struct AR_VMP_Header *vmp_header)
{
	return static_intf::qxGetARVMPOfCurrentVMR(vmp_i, vmp_header);
}

int qxSetARVMPParametersOfCurrentVMR(int vmp_i, struct AR_VMP_Header *vmp_header)
{
	return static_intf::qxSetARVMPParametersOfCurrentVMR(vmp_i, vmp_header);
}

int qxLoadARVMPsToCurrentVMR(const char *VMPFile)
{
	return static_intf::qxLoadARVMPsToCurrentVMR(VMPFile);
}

void qxSaveARVMPsOfCurrentVMR(const char *VMPFile)
{
	return static_intf::qxSaveARVMPsOfCurrentVMR(VMPFile);
}

int qxCreateARVMPsForCurrentVMR(int n_maps, struct AR_VMPs_Header *vmps_header)
{
	return static_intf::qxCreateARVMPsForCurrentVMR(n_maps, vmps_header);
}

void qxDeleteARVMPsOfCurrentVMR()
{
	static_intf::qxDeleteARVMPsOfCurrentVMR();
}


// VTC
int qxLinkVTCToCurrentVMR(const char *filename, int loadInMem)
{
	return static_intf::qxLinkVTCToCurrentVMR(filename, loadInMem);
}

int qxCreateVTCForCurrentVMR(int nTimePoints, struct VTC_Header *vtc_header)
{
        return static_intf::qxCreateVTCForCurrentVMR(nTimePoints, vtc_header);
}

int qxGetHeaderOfVTCOfCurrentVMR(struct VTC_Header *vtc_header)
{
        return static_intf::qxGetHeaderOfVTCOfCurrentVMR(vtc_header);
}

int qxSetHeaderOfVTCOfCurrentVMR(struct VTC_Header *vtc_header)
{
        return static_intf::qxSetHeaderOfVTCOfCurrentVMR(vtc_header);
}

int qxSetVTCParametersOfCurrentVMR(struct VTC_Header *vtc_header)
{
        return static_intf::qxSetVTCParametersOfCurrentVMR(vtc_header);
}


float * qxGetVTCFloatDataOfCurrentVMR()
{
    return static_intf::qxGetVTCFloatDataOfCurrentVMR();   // NEW in BVQX v2.0 - use to get float ptr to whole VTC data
}

short * qxGetVTCIntDataOfCurrentVMR()
{
    return static_intf::qxGetVTCIntDataOfCurrentVMR();      // NEW in BVQX v2.0 - use to get short int ptr to whole VTC data
}

short * qxGetVTCOfCurrentVMR(struct VTC_Header *vtc_h)
{
    return static_intf::qxGetVTCOfCurrentVMR(vtc_h);        // deprecated in BVQX 2.0 -> use fns above
}

void qxSaveVTCOfCurrentVMR(const char *filename)
{
    static_intf::qxSaveVTCOfCurrentVMR(filename);
}

// Multi-VTC
int qxClearMultiVTCAnalysis()
{
	return static_intf::qxClearMultiVTCAnalysis();
}

int qxAddVTCRefForMultiVTCAnalysis(const char *filename)
{
	return static_intf::qxAddVTCRefForMultiVTCAnalysis(filename);
}

int qxGetVoxelTimeCourseOfVTC(int i1, int i2, float *tc)
{
	return static_intf::qxGetVoxelTimeCourseOfVTC(i1, i2, tc);
}

int qxGetVoxelTimeCourseOfVTCs(int i1, float *tc)
{
	return static_intf::qxGetVoxelTimeCourseOfVTCs(i1, tc);
}

int qxGetVoxelCoordsTimeCourseOfVTC(int i1, int i2, int i3, int i4, float *tc)
{
	return static_intf::qxGetVoxelCoordsTimeCourseOfVTC(i1, i2, i3, i4, tc);
}

int qxGetVoxelCoordsTimeCourseOfVTCs(int i1, int i2, int i3, float *tc)
{
	return static_intf::qxGetVoxelCoordsTimeCourseOfVTCs(i1, i2, i3, tc);
}

// GLM
float * qxGetGLMOfCurrentVMR(struct GLM_Header *glm_header)
{
	return static_intf::qxGetGLMOfCurrentVMR(glm_header);
}

// MSK
int qxLoadMaskToCurrentVMR(const char *filename)
{
	return static_intf::qxLoadMaskToCurrentVMR(filename);
}

unsigned char * qxGetMaskOfCurrentVMR()
{
	return static_intf::qxGetMaskOfCurrentVMR();
}

// SRF
int qxGetScene(struct SCENE_Header *scene_header)
{
	return static_intf::qxGetScene(scene_header);
}

int qxGetCurrentSRF(struct SRF_Header *srf_header)
{
	return static_intf::qxGetCurrentSRF(srf_header);
}

void qxSaveCurrentSRF(const char *filename)
{
	return static_intf::qxSaveCurrentSRF(filename);
}

int qxSetCurrentSRF(int index)
{
	return static_intf::qxSetCurrentSRF(index);
}

// SMP
int qxGetSMPsOfCurrentSRF(struct SMPs_Header *smps_header)
{
	return static_intf::qxGetSMPsOfCurrentSRF(smps_header);
}

float * qxGetSMPOfCurrentSRF(int index, struct SMP_Header *smp_header)
{
	return static_intf::qxGetSMPOfCurrentSRF(index, smp_header);
}

int qxSetSMPParametersOfCurrentSRF(int index, struct SMP_Header *smp_header)
{
	return static_intf::qxSetSMPParametersOfCurrentSRF(index, smp_header);
}

int qxLoadSMPsToCurrentSRF(const char *filename)
{
	return static_intf::qxLoadSMPsToCurrentSRF(filename);
}

void qxSaveSMPsOfCurrentSRF(const char *filename)
{
	return static_intf::qxSaveSMPsOfCurrentSRF(filename);
}

int qxCreateSMPForCurrentSRF()
{
	return static_intf::qxCreateSMPForCurrentSRF();
}

void qxDeleteSMPsOfCurrentSRF()
{
	static_intf::qxDeleteSMPsOfCurrentSRF();
}

void qxOverlaySMPsOnSRF()
{
	static_intf::qxOverlaySMPsOnSRF();
}

// MTC
int qxLinkMTCToCurrentSRF(const char *filename, int loadInMem)
{
	return static_intf::qxLinkMTCToCurrentSRF(filename, loadInMem);
}

int qxCreateMTCForCurrentSRF(int nTimePoints)
{
	return static_intf::qxCreateMTCForCurrentSRF(nTimePoints);
}

float ** qxGetMTCOfCurrentSRF(struct MTC_Header *mtc_header)
{
	return static_intf::qxGetMTCOfCurrentSRF(mtc_header);
}

int qxSetMTCParametersOfCurrentSRF(struct MTC_Header *mtc_header)
{
	return static_intf::qxSetMTCParametersOfCurrentSRF(mtc_header);
}

void qxSaveMTCOfCurrentSRF(const char *filename)
{
	static_intf::qxSaveMTCOfCurrentSRF(filename);
}

// Multi-MTC (file-based read access)
int qxClearMultiMTCRefsOfCurrentSRF()
{
    return static_intf::qxClearMultiMTCRefsOfCurrentSRF();
}

int qxAddMultiMTCRefToCurrentSRF(const char *mtc_file)
{
    return static_intf::qxAddMultiMTCRefToCurrentSRF(mtc_file);
}

int qxGetVertexTimeCourseOfMTC(int i1, int i2, float *pf1)
{
    return static_intf::qxGetVertexTimeCourseOfMTC(i1, i2, pf1);
}

int qxGetVertexTimeCourseOfAllMTCs(int i1, float *pf1)
{
    return static_intf::qxGetVertexTimeCourseOfAllMTCs(i1, pf1);
}


// SSM
int *qxGetSSMOfCurrentSRF(struct SSM_Header *ssm_header)
{
	return static_intf::qxGetSSMOfCurrentSRF(ssm_header);
}

int qxLoadSSMToCurrentSRF(const char *file)
{
	return static_intf::qxLoadSSMToCurrentSRF(file);
}

void qxSaveSSMOfCurrentSRF(const char *file)
{
	static_intf::qxSaveSSMOfCurrentSRF(file);
}

int qxCreateSSMForCurrentSRF()
{
	return static_intf::qxCreateSSMForCurrentSRF();
}

void qxDeleteSSMOfCurrentSRF()
{
	static_intf::qxDeleteSSMOfCurrentSRF();
}


// PRT
void qxClearProtocol()
{
	static_intf::qxClearProtocol();
}

int qxLoadProtocol(const char *ProtocolFile)
{
	return static_intf::qxLoadProtocol(ProtocolFile);
}

int qxSaveProtocol(const char *ProtocolFile)
{
	return static_intf::qxSaveProtocol(ProtocolFile);
}

int qxGetProtocol(struct Protocol_Header *prt_header)
{
	return static_intf::qxGetProtocol(prt_header);
}

int qxSetProtocol(struct Protocol_Header *prt_header)
{
	return static_intf::qxSetProtocol(prt_header);
}

int qxGetProtocolCondition(int index, struct ProtocolCondition_Header *prt_cond_header)
{
	return static_intf::qxGetProtocolCondition(index, prt_cond_header);
}

int qxAddProtocolCondition(struct ProtocolCondition_Header *prtcond_header)
{
	return static_intf::qxAddProtocolCondition(prtcond_header);
}

int qxAddProtocolConditionInterval(int cond, int from, int to)
{
	return static_intf::qxAddProtocolConditionInterval(cond, from, to);
}


// PRED, DM, HRF
int qxClearDesignMatrix()
{
	return static_intf::qxClearDesignMatrix();
}

int qxAddPredictor(const char *name)
{
	return static_intf::qxAddPredictor(name);
}

int qxSetPredictorValuesFromCondition(const char *predName, int condIndex, float predValue)
{
	return static_intf::qxSetPredictorValuesFromCondition(predName, condIndex, predValue);
}

int qxSetPredictorValuesFromConditionName(const char *predName, const char *condName, float predVal)
{
	return static_intf::qxSetPredictorValuesFromConditionName(predName, condName, predVal);
}

int qxApplyTwoGammaHRFToPredictor(int predIndex)
{
	return static_intf::qxApplyTwoGammaHRFToPredictor(predIndex);
}

int qxApplyTwoGammaHRFToPredictorWithName(const char *predName)
{
	return static_intf::qxApplyTwoGammaHRFToPredictorWithName(predName);
}

int qxApplyBoyntonHRFToPredictor(int predIndex)
{
	return static_intf::qxApplyBoyntonHRFToPredictor(predIndex);
}

int qxApplyBoyntonHRFToPredictorWithName(const char *predName)
{
	return static_intf::qxApplyBoyntonHRFToPredictorWithName(predName);
}

float * qxGetPredictor(int index)
{
	return static_intf::qxGetPredictor(index);
}

float * qxGetPredictorByName(const char *predName)
{
	return static_intf::qxGetPredictorByName(predName);
}

int qxLoadSingleStudyGLMDesignMatrix(const char *filename)
{
	return static_intf::qxLoadSingleStudyGLMDesignMatrix(filename);
}

int qxSaveSingleStudyGLMDesignMatrix(const char *filename)
{
	return static_intf::qxSaveSingleStudyGLMDesignMatrix(filename);
}

// VOI
int qxLoadVOIs(const char *voi_filename)
{
    return static_intf::qxLoadVOIs(voi_filename);
}

int qxSaveVOIs(const char *voi_filename)
{
    return static_intf::qxSaveVOIs(voi_filename);
}

int qxGetVOIs(struct VOIs_Header *vois_header)
{
	return static_intf::qxGetVOIs(vois_header);
}

int * qxGetVOI(int index, struct VOI_Header *voi_header)
{
	return static_intf::qxGetVOI(index, voi_header);
}

// POI
int qxLoadPOIs(const char *poi_filename)
{
    return static_intf::qxLoadPOIs(poi_filename);
}

int qxSavePOIs(const char *poi_filename)
{
    return static_intf::qxSavePOIs(poi_filename);
}

int qxGetPOIs(struct POIs_Header *pois_header)
{
	return static_intf::qxGetPOIs(pois_header);
}

int * qxGetPOI(int index, struct POI_Header *poi_header)
{
	return static_intf::qxGetPOI(index, poi_header);
}

// parameter access for GUI plugins - scripts exchange
int qxGetStringParameter(char *param_name, char *str)
{
	return static_intf::qxGetStringParameter(param_name, str);
}

int qxGetIntParameter(char *param_name)
{
	return static_intf::qxGetIntParameter(param_name);
}

float qxGetFloatParameter(char *param_name)
{
	return static_intf::qxGetFloatParameter(param_name);
}

void qxSetStringParameter(char *param_name, char *str)
{
	static_intf::qxSetStringParameter(param_name, str);
}

void qxSetIntParameter(char *param_name, int ival)
{
	static_intf::qxSetIntParameter(param_name, ival);
}

void qxSetFloatParameter(char *param_name, float fval)
{
	return static_intf::qxSetFloatParameter(param_name, fval);
}


// dialog access (internal use)
int qxGetDlgStringParameter(int index, const char *str)
{
	return static_intf::qxGetDlgStringParameter(index, str);
}

int qxGetDlgIntegerParameter(int index)
{
	return static_intf::qxGetDlgIntegerParameter(index);
}

float qxGetDlgFloatParameter(int index)
{
	return static_intf::qxGetDlgFloatParameter(index);
}

void qxSetDlgStringOutputParameter(int index, const char *str)
{
    static_intf::qxSetDlgStringOutputParameter(index, str);
}

void qxSetDlgIntegerOutputParameter(int index, int ival)
{
    static_intf::qxSetDlgIntegerOutputParameter(index, ival);
}

void qxSetDlgFloatOutputParameter(int index, float fval)
{
    return static_intf::qxSetDlgFloatOutputParameter(index, fval);
}


void qxLaunchICADialog()
{
	static_intf::qxLaunchICADialog();
}



bool InitQXAccess()
{
	return static_intf::InitQXAccess();
}

bool checkVersionGreaterEqualVersion(int MajorA, int MinorA, int SubMinorA, int MajorB, int MinorB, int SubMinorB)
{
	if(MajorA > MajorB)
		return true;

	if(MajorB > MajorA)
		return false;

	// Major is equal, Minor decides

	if(MinorA > MinorB)
		return true;

	if(MinorB > MinorA)
		return false;

	// Minor is equal, SubMinor decides

	if(SubMinorA >= SubMinorB)
		return true;

	// B smaller
	return false;
}
