

#include "Plugin_POI_Header.h"

#ifndef POI_HEADER_H
#define POI_HEADER_H

/*
 
 FileVersion: 2
 
 FromMeshFile: "CG_LH_INFL.srf"
 
 NrOfMeshVertices: 40962
 
 
 NrOfPOIs: 4
 
 NameOfPOI:    "Frontal Lobe"
 InfoTextFile: "frontal_lobe.html"
 ColorOfPOI:   254 80 80
 LabelVertex:  570
 
 NrOfVertices: 11789
 

 */

// header for ONE POI
typedef struct {
	int  NrOfVertices;
	char *POIName;
	int  ColorOfPOI; //Display color, from RGB + startvalue;
	
	int  ReferenceVertex;    // New in BVQX v2.0: LabelVertex: ...
	char *InfoFileName;  // New in BVQX v2.0	InfoTextFile: ...
	
	int *POIdata;
} poiSubStruct;

typedef struct {
	int FileVersion;
	char *FromMeshFile;
	int NrOfMeshVertices;
	int  NrOfPOIs;
	int  NrOfPOIMTCs;
	char *POIsFileName; // 261 chars reserved (empty C string ("") if not available)
	poiSubStruct *poi;  
	
	// BrainVoyager specific header
	bool flag_bvqxhdr; 
	POIs_Header *poibvqx;
} poiStruct;


#endif // POI_HEADER_H


