
#ifndef PLUGIN_ICA_HEADER_H
#define PLUGIN_ICA_HEADER_H

// header for ICA with global data
//
struct ICA_Header	 {

	int NrOfComponents;
	int NrOfTimePoints;
	int NrOfComponentParams;

	char *VTCFileName;		// 261 chars reserved (empty C string ("") if not provided)
	char *ProtocolFileName; // 261 chars reserved (emtpy C string ("") if not provided)
	char *VOIFileName;      // 261 chars reserved (empty C string ("") if not provided)

	int XStart;  // do NOT change right now: if these 6 values are changed, you MUST also change the allocated memory of this and all other ICs !
	int XEnd;
	int YStart;
	int YEnd;
	int ZStart;
	int ZEnd;
	int Resolution; // normally "3"

	char **NamesOfComponentParameters; // 51 chars per param

	// Note that X/Y/Z/End values are exclusive (as VTCs/GLMs), compute dims as:
	// dim_x = (XEnd - XStart)/Resolution;
	// dim_y = (YEnd - YStart)/Resolution;
	// dim_z = (ZEnd - ZStart)/Resolution;
};

// header for ONE independent component
//
struct IC_Header {

	int   ColorMin;
	int   ColorMax;
	int   UseICColor;
	float TransparentColorFactor;

	char  *NameOfComponent;		// 101 chars

	int   OverlayMap;			// get/set whether this component is shown

	float *TimeCourse;			// defined only if "(NrOfTimePoints > 0)", otherwise NULL ptr

	float *ComponentParams;		// defined only if "(NrOfComponentParams > 0)", otherwise NULL ptr
};

#endif // PLUGIN_ICA_HEADER_H