#include "Plugin_SMP_Header.h"

#ifndef SMP_HEADER_H
#define SMP_HEADER_H



// this is the map structure (there could be several of these)
typedef struct {

	int mapType; 
	int nrOfLags; // if maptype 3
	int minLag;   // if maptype 3
	int maxLag;   // if maptype 3
	int ccOverlay;	// if maptype 3
	int clusterSize; 
	unsigned char enableClusterCheck; 
	float critValThresh;
	float maxThresh;	
	int useValuesAboveThreshold; // > v3
	int contrXrcmaps; // Only used if MapType = crosscorrelation (3)
	int df1;
	int df2; // Only used if MapType = 1
	int showPosNegFlag; // file version 5.
	int bonfCorr; 
	unsigned char RGBLowerThreshPos[3]; // file version 3
	unsigned char RGBUpperThreshPos[3]; // file version 3
	unsigned char RGBLowerThreshNeg[3]; // file version 4
	unsigned char RGBUpperThreshNeg[3]; // file version 4
	unsigned char enableSMPcolor;
	char *LUTName; // file version 5
	float transparentColorFactor;
	char *surfaceMapName;
	float *mapData;

} srfStatMap;
	 
// this is the main structure (only 1)
typedef struct {

	short int versionNr; 
	int nrOfVertices;
	short int nrOfMaps;  
	char *srfFileName;
	char *origName;
	srfStatMap *srfStatMaps;

	// BrainVoyager specific header
	bool flag_bvqxhdr; 
	SMPs_Header *smpbvqx;


} smpStruct;

#endif // SMP_HEADER_H
	