
#include <vector>
#include "Plugin_SRF_Header.h"


#ifndef SRF_HEADER_H
#define SRF_HEADER_H



typedef struct {

	int nrOfNeighbours;
	int *neighbourLst; // varying nr of neighbours: between 4 and 7(?)

} neighbours;


typedef struct {

	float fileVersion;// version number of surface file; default: 3
	unsigned int reserved;// reserved, must be '0'
	unsigned int NrOfVertices;//  number of vertices
	unsigned int NrOfTriangles;// number of triangles
	//int NrOfVertices;//  number of vertices
	//int NrOfTriangles;// number of triangles

	float MeshCenterX;// center of mesh on X-axis; default coordinate: 128
	float MeshCenterY;// center of mesh on Y-axis; default coordinate: 128
	float MeshCenterZ;// center of mesh on Z-axis; default coordinate: 128
	float *VertexX;// sequence of X coordinates of all vertices
	float *VertexY;// sequence of Y coordinates of all vertices
	float *VertexZ;// sequence of Z coordinates of all vertices
	float *NormalX;// sequence of X components of all vertex normals
	float *NormalY;// sequence of Y components of all vertex normals
	float *NormalZ;// sequence of Z components of all vertex normals

	float ConvCurvRed;//R component of convex curvature color (range: 0.0 - 1-0); default: 0.322
	float ConvCurvGreen;// G component of convex curvature color (range: 0.0 - 1-0); default: 0.733
	float ConvCurvBlue;// B component of convex curvature color (range: 0.0 - 1-0); default: 0.980
	float ConvCurvAlpha;// Alpha component of convex curvature color (range: 0.0 - 1-0); default: 0.500
	float ConcCurvRed;// R component of convex curvature color (range: 0.0 - 1-0); default: 0.100
	float ConcCurvGreen;// G component of concave curvature color (range: 0.0 - 1-0); default: 0.240
	float ConcCurvBlue;// B component of concave curvature color (range: 0.0 - 1-0); default: 0.320
	float ConcCurvAlpha;// Alpha component of concave curvature color (range: 0.0 - 1-0); default: 0.500
	int *MeshColor;// Sequence of color indices of all vertices (*1)
	// >>> omzetten naar int *VertexColor;

	neighbours *neighb;
	int totalneighbourelems;
	
	int UseTriangleStrip; //added 26-02-09
	int *triangleSequence;
	int nrOfTriangleStripElements;
	int *stripElemSequence;
	char *origName;

	// BrainVoyager specific header
	bool flag_bvqxhdr; 
	SRF_Header *srfbvqx;


} srfStruct;

#endif // SRF_HEADER_H
