
#ifndef BVQX_IO_H 
#define BVQX_IO_H

/*
#include <iostream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <fstream>
*/

#include "SRF_Header.h"
#include "MTC_Header.h"
#include "SMP_Header.h"
#include "POI_Header.h"


// for intent code
/*
#define BVQXTTESTVALS		1
#define BVQXCORRVALS		2
#define	BVQXCROSSCORRVALS	3
#define	BVQXFTESTVALS		4
#define BVQXPERCSIGNCHVALS	11
*/
const int ERROR_NO_FILE_ACCESS = 90;

// new, 19-11-08, from Joost
float** create2dArray(int rows, int cols);
void delete2dArray(float **ar, int rows, int cols); 
int** create2dIntArray(int rows, int cols);
void delete2dIntArray(int **ar, int rows, int cols);

char *removeExtension(char *fileName);
char *exchangeExtension(char *currentFileName, char *newExtension);
char *getStatMapStr(int statMapType);


//reads version 3 and 4
srfStruct *getsrf(char *filename, bool exportfromdisk); 
bool readsrf(char *srfFileName, srfStruct *srf);
// reads version 1
mtcStruct *getmtc(char *filename, bool exportfromdisk);
bool readmtc(char *mtcFileName, mtcStruct *mtc);
// reads version 3, 4 and 5
smpStruct *getsmp(char *filename, bool exportfromdisk);
bool readsmp(char *smpFileName, smpStruct *smp);
// reads from version 2
poiStruct *getpoi(char *filename, bool exportfromdisk);
bool readpoi(char *poiFileName, poiStruct *poi);

// please note: the code below will write "old" versions?
bool writesrf(srfStruct *srf);
bool writemtc(mtcStruct *mtc);
bool writesmp(smpStruct *smp);
bool writepoi(poiStruct *poi);

#endif // BVQX_IO_H
