function vertexnormal = calculate_vertex_normal(vertex_nr, srf);
% ==================
% calculate_vertex_normal(vertex_nr, srf)
%
%   vertex_nr = number of the vertex which normal should be calculated
%   srf = BVQXtools srf object
%
% ==================

VC = srf.VertexCoordinate;

%find triangles in which vertex nr 1 is present
[x,y] = find(srf.TriangleVertex == vertex_nr);
tri = srf.TriangleVertex(x,:);

normals = zeros(size(tri,1),3);

%compute the normal for each triangle (with vertex 1 in it)
for i = 1:size(tri,1)
  normals(i,:) = cross(VC(tri(i,2),:)-VC(tri(i,1),:), VC(tri(i,3),:) - VC(tri(i,2),:));
  normals(i,:) = normals(i,:)/norm(normals(i,:))
end

%calculate the final vertex normal
vertexnormal = sum(normals)/norm(sum(normals)); 
