
// constants.h for GIFTI plugin

static const char *pluginversion = "1.5";

const float PI = 3.1415926536;

const int ERROR_TYPE_UNDEFINED = 0;
const int ERROR_TYPE_FILE_SEL = 1;


enum FileTypes {TypeGifti = 1, TypeSrf, TypeMtc, TypeSmp, TypePoi};

// BrainVoyager QX map types (add: chisquare, z, etc, see release notes)

const int BVQX_MAPTYPE_UNKNOWN					= 0;

/*!
@const BVQX_MAPTYPE_T_STAT
@abstract BrainVoyager code for T-statistic
*/
const long int  BVQX_MAPTYPE_T_STAT				= 1;

const long int BVQX_MAPTYPE_CURVATURE			= 1;
const long int BVQX_MAPTYPE_FA					= 22;
const long int BVQX_MAPTYPE_MD					= 21;

/*!
@const BVQX_MAPTYPE_CORRELATION
@abstract BrainVoyager code for correlation
*/
const long int  BVQX_MAPTYPE_CORRELATION		= 2;
/*!
@const BVQX_MAPTYPE_CROSSCORRELATION
@abstract BrainVoyager code for cross-correlation
*/
const long int 	BVQX_MAPTYPE_CROSSCORRELATION	= 3;
/*!
@const BVQX_MAPTYPE_F_STAT
@abstract BrainVoyager code for F-statistic
*/
const long int 	BVQX_MAPTYPE_F_STAT				= 4;
/*!
@const BVQX_MAPTYPE_Z_STAT
@abstract BrainVoyager code for z-value
*/
const long int BVQX_MAPTYPE_Z_STAT				= 5;
/*!
@const BVQX_MAPTYPE_PSC
@abstract BrainVoyager code for percent signal change
*/
const long int  BVQX_MAPTYPE_PSC				= 11;
/*!
@const BVQX_MAPTYPE_ICA
@abstract BrainVoyager code for independent component analysis
*/
const long int BVQX_MAPTYPE_ICA					= 12;
/*!
@const BVQX_MAPTYPE_CHI2
@abstract BrainVoyager code for chi^2
*/
const long int BVQX_MAPTYPE_THICKNESS			= 13;
/*!
@const BVQX_MAPTYPE_THICKNESS
@abstract BrainVoyager code for Cortical Thickness
*/
const long int BVQX_MAPTYPE_CHI2				= 14;
/*!
@const BVQX_MAPTYPE_BETA
@abstract BrainVoyager code for beta map
*/
const long int BVQX_MAPTYPE_BETA				= 15;


const long int  BVQX_MAPTYPE_RETINOTOPY_POLAR			= 16;
const long int  BVQX_MAPTYPE_RETINOTOPY_ECCENTRICITY	= 17;
const long int  BVQX_MAPTYPE_RETINOTOPY_FIELD_SIGN		= 18;

