

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <exception>

#include "BVQXPluginInterfaceExtern.h"
#include "convertbvqxstructs.h"
#include "Plugin_MTC_Header.h"
#include "Plugin_SMP_Header.h"
#include "Plugin_SRF_Header.h"
#include "bvqx_io.h"
#include "SRF_Header.h"
#include "MTC_Header.h"
#include "SMP_Header.h"
#include "constants.h"


// to our struct
srfStruct *convertSRF(SRF_Header *srfbvqx) {

	srfStruct *srf = new srfStruct;
	qxLogText(srfbvqx->MeshFileName);
//	srf->origName = srfbvqx->MeshFileName;
	char *name = new char[256];
	sprintf(name, srfbvqx->MeshFileName);
	qxLogText(name);
	srf->origName = name;
//	strcpy(srf->origName, name);
	//srf->fileVersion;
	srf->MeshCenterX = srfbvqx->MeshCenterX;
	srf->MeshCenterY = srfbvqx->MeshCenterY;
	srf->MeshCenterZ = srfbvqx->MeshCenterZ;
	srf->VertexX = srfbvqx->VertexX;
	srf->VertexY = srfbvqx->VertexY;
	srf->VertexZ = srfbvqx->VertexZ;
	srf->NormalX = srfbvqx->NormalX;
	srf->NormalY = srfbvqx->NormalY;
	srf->NormalZ = srfbvqx->NormalZ;
	srf->ConcCurvAlpha	= 1.0; 
	srf->ConcCurvRed	= srfbvqx->Base2ColorR;
	srf->ConcCurvGreen	= srfbvqx->Base2ColorG;
	srf->ConcCurvBlue	= srfbvqx->Base2ColorB;
	srf->ConvCurvAlpha	= 1.0;
	srf->ConvCurvRed	= srfbvqx->Base1ColorR;
	srf->ConvCurvGreen	= srfbvqx->Base1ColorG;
	srf->ConvCurvBlue	= srfbvqx->Base1ColorB;
	srf->NrOfTriangles	= srfbvqx->NrOfTriangles;
	srf->NrOfVertices	= srfbvqx->NrOfVertices;
	srf->MeshColor		= srfbvqx->VertexColor;
	srf->reserved		= 0;
//	srf->neighb;
//	srfbvqx->VertexNeighbors;

	int *triseq = new int[srf->NrOfTriangles * 3];			  
	int counter;
	int incounter = 0;

	for (counter = 0; counter < srf->NrOfTriangles; counter++) {

			triseq[incounter] = srfbvqx->Triangles[counter].v1;
			incounter++;
			triseq[incounter] = srfbvqx->Triangles[counter].v2;
			incounter++;
			triseq[incounter] = srfbvqx->Triangles[counter].v3;
			incounter++;									  
		
	}												  
	srf->triangleSequence = triseq;

//	int *NrOfVertexNeighbors;
//	int **VertexNeighborhood;

//	Vertex_Neighbors *nbqx = srfbvqx->VertexNeighbors;
// 	Vertex_Neighbors *nbqx = srfbvqx->NrOfVertexNeighbors;
// 	int vertexCounter, nbcounter;
// 	int nrOfNeighbours;
// 	neighbours *neighboursPtrContainer = new neighbours[srf->NrOfVertices];
// 	int elemcounter = 0;
/*	for (vertexCounter = 0; vertexCounter < srf->NrOfVertices; vertexCounter++) {

		nrOfNeighbours = nbqx[vertexCounter].N;
		neighboursPtrContainer[vertexCounter].nrOfNeighbours = nrOfNeighbours;
		elemcounter+= (nrOfNeighbours + 1);
		int neighbSize = nrOfNeighbours * sizeof(int);
		elemcounter += nrOfNeighbours;
		int *neighb = new int[nrOfNeighbours];
		for (nbcounter=0; nbcounter < nrOfNeighbours; nbcounter++) {
			 neighb[nbcounter] = nbqx[vertexCounter].nbr[nbcounter];
		} 
		neighboursPtrContainer[vertexCounter].neighbourLst = neighb;
	}				
*/
//	srf->totalneighbourelems = elemcounter;
// 	srf->neighb = neighboursPtrContainer;
// 	srf->nrOfTriangleStripElements = 0;
//	srf->mtcFileName = "<none>";
	// DUS NOG TOEVOEGEN 

	return srf;
}

// to BVQX struct
bool convertSRF(srfStruct *srf) {

	bool success = true;
	SRF_Header *srfbvqx = new SRF_Header;
	srfbvqx->NrOfVertices = srf->NrOfVertices;
	srfbvqx->NrOfTriangles = srf->NrOfTriangles;
	srfbvqx->MeshCenterX = srf->MeshCenterX;
	srfbvqx->MeshCenterY = srf->MeshCenterY;
	srfbvqx->MeshCenterZ = srf->MeshCenterZ;
	srfbvqx->VertexX = srf->VertexX;
	srfbvqx->VertexY = srf->VertexY;
	srfbvqx->VertexZ = srf->VertexZ;
	srfbvqx->NormalX = srf->NormalX;
	srfbvqx->NormalY = srf->NormalY;
	srfbvqx->NormalZ = srf->NormalZ;
	// assume colors are generated by BVQX
	// assume meshrotx/y/z are generated by BVQX
	// assume visible rendermode are generated by BVQX

	char *srfname = new char[260];
	strcpy(srfname, srf->origName);
	srfbvqx->MeshFileName = srfname;

	srfbvqx->UseTriangleStrip = srf->UseTriangleStrip;
	srfbvqx->NrOfStripElements = srf->nrOfTriangleStripElements;
	
	// convert triangles 
	Triangle_Vertices *trianglestruct = new Triangle_Vertices[srf->NrOfTriangles];
	int counter;
	int incounter = 0;
	for (counter = 0; counter < srf->NrOfTriangles; counter++) {

		trianglestruct[counter].v1 = srf->triangleSequence[incounter];
		incounter++;
		trianglestruct[counter].v2 = srf->triangleSequence[incounter];
		incounter++;
		trianglestruct[counter].v3 = srf->triangleSequence[incounter];
		incounter++;									  
	}												  
	srfbvqx->Triangles = trianglestruct;

	// convert neighbours
	int *NrOfVertexNeighbors = new int[srf->NrOfVertices];
	int** VertexNeighborhood = new int*[srf->NrOfVertices];
	for (int i = 0; i<srf->NrOfVertices; i++) {
		NrOfVertexNeighbors[i] = srf->neighb[i].nrOfNeighbours;
		VertexNeighborhood[i] = new int[srf->neighb[i].nrOfNeighbours];
		for (int j=0; j<srf->neighb[i].nrOfNeighbours; j++){
			VertexNeighborhood[i][j] = srf->neighb[i].neighbourLst[j];
		}
	}
	srfbvqx->NrOfVertexNeighbors = NrOfVertexNeighbors;
	srfbvqx->VertexNeighborhood = VertexNeighborhood;

	srf->srfbvqx = srfbvqx;
	srf->flag_bvqxhdr = true;
	return success;

}

// for export
mtcStruct *convertMTC(MTC_Header *mtcbvqx, float **data) {

	mtcStruct *mtc = new mtcStruct;
	mtc->vtcFileName = mtcbvqx->CreatedFromVTC;
	mtc->fileVersion = 1;
	mtc->prtFileName = mtcbvqx->LinkedProtocolName;
	mtc->nrOfVolumes = mtcbvqx->NrOfTimePoints;
	mtc->nrOfVertices = mtcbvqx->NrOfVertices;
	mtc->TR = mtcbvqx->TR;
	//mtcbvqx->InMemory;
	//mtcbvqx->HeaderSize;
	mtc->origName = mtcbvqx->MTCFileName;
	//mtc->fileVersion;!!!!!!
	//mtc->hemoDynDelay;
	mtc->HRFdelta;
	mtc->HRFtau;
	mtc->segmentOffset;
	mtc->segmentSize;
	
	float *mtcseq = new float[mtc->nrOfVertices*mtc->nrOfVolumes];			  
	int counter = 0;
	int nrvol;
	int nrvertex;
	for (nrvol = 0; nrvol < mtc->nrOfVolumes; nrvol++){
		for (nrvertex = 0; nrvertex < mtc->nrOfVertices; nrvertex++) {
			mtcseq[counter]= data[nrvertex][nrvol];
			counter++;
		}
	}												  
	mtc->data = mtcseq;
	return mtc;
	
}

// for import
bool convertMTC(mtcStruct *mtc) {

	bool success = true;
	
	// 0. checks
	SRF_Header *srfbvqx = new SRF_Header;
	int suc6 = qxGetCurrentSRF(srfbvqx);
	if ((suc6 < 1) || (srfbvqx->NrOfVertices != mtc->nrOfVertices)) {
		qxMessageBox("The number of vertices of the time series is not equal to number of vertices in surface. Process terminated.");
		return false;
	}

	// 1. create structures
	MTC_Header *mtcbvqx = new MTC_Header;
	int NrOfTimePoints=mtc->nrOfVolumes;
	qxCreateMTCForCurrentSRF(NrOfTimePoints);
	float **bvqxdata = qxGetMTCOfCurrentSRF(mtcbvqx); 
	
	// convert header fields
	strcpy(mtcbvqx->MTCFileName, mtc->origName);
	strcpy(mtcbvqx->CreatedFromVTC, mtc->vtcFileName);
	strcpy(mtcbvqx->LinkedProtocolName, mtc->prtFileName);
	mtcbvqx->NrOfTimePoints = mtc->nrOfVolumes;
	mtcbvqx->NrOfVertices = mtc->nrOfVertices;
	mtcbvqx->TR = mtc->TR;
	mtcbvqx->InMemory = 1;
	//mtcbvqx->HeaderSize; // we assume that BrainVoyager calculates a proper default value here
	mtcbvqx->DataType = mtc->MTCDataType;	

	// convert data to other array type
	int counter = 0;
	int nrvol;
	int nrvertex;
	for (nrvol = 0; nrvol < mtc->nrOfVolumes; nrvol++){
		for (nrvertex = 0; nrvertex < mtc->nrOfVertices; nrvertex++) {
			bvqxdata[nrvertex][nrvol] = mtc->data[counter];//mtcseq[counter];
			counter++;
		}
	}		
	
	mtc->flag_bvqxhdr = true;
	mtc->mtcbvqx = mtcbvqx;
	qxSetMTCParametersOfCurrentSRF(mtc->mtcbvqx);
	return success;
} 

// changed 26-11-08: convert all SMP maps instead of 1
smpStruct *convertSMP(SMPs_Header *bvqxsmps) {//, SMP_Header *smpbvqx, float *data, int mapnr){

	smpStruct *smp								= new smpStruct;
	srfStatMap *smpmaps							= new srfStatMap[bvqxsmps->NrOfSMPs];

	// get general header stuff
	smp->origName								= bvqxsmps->SMPFileName;
	char ext[] = ".srf";
	smp->srfFileName							= exchangeExtension(bvqxsmps->SMPFileName, ext);
	char *logtxt = new char[256];
	sprintf(logtxt, "SMP name: %s", smp->origName);
	qxLogText(logtxt);

	//smp->nrOfMaps = smph->NrOfSMPs; //  not used, just convert 1 map
	smp->nrOfMaps								= bvqxsmps->NrOfSMPs;
	smp->nrOfVertices							= bvqxsmps->NrOfVertices;
	smp->versionNr								= 2; // ?

	// get specific header stuff
	int mapnr;
	for (mapnr=0; mapnr< bvqxsmps->NrOfSMPs; mapnr++) {

		SMP_Header *bvxqsmp					= new SMP_Header;
		float *data						= qxGetSMPOfCurrentSRF(mapnr, bvxqsmp);
		smpmaps[mapnr].df1				= bvxqsmp->df1;
		smpmaps[mapnr].df2				= bvxqsmp->df2;
		smpmaps[mapnr].mapType			= bvxqsmp->MapType;
		smpmaps[mapnr].surfaceMapName	= bvxqsmp->NameOfSMP;

		if (bvxqsmp->MapType == BVQX_MAPTYPE_CROSSCORRELATION) {
			smpmaps[mapnr].ccOverlay				= bvxqsmp->OverlayMap;
			//	smpmaps[mapnr].nrOfLags				= bvxqsmp->;
			smpmaps[mapnr].minLag					= 0;
			smpmaps[mapnr].maxLag					= 0;
			smpmaps[mapnr].contrXrcmaps;
		}
		smpmaps[mapnr].critValThresh = bvxqsmp->ThreshMin; // let op: type error 'bvxq'
		smpmaps[mapnr].maxThresh = bvxqsmp->ThreshMax;

		//	smpmaps[mapnr].RGBLowerThreshNeg = bvxqsmp->ColorNegMax;
		//	smpmaps[mapnr].RGBLowerThreshPos = bvxqsmp->ColorPosMax;
		//	smpmaps[mapnr].RGBLowerThreshNeg = bvxqsmp->ColorNegMax;
		//	smpmaps[mapnr].RGBLowerThreshNeg = bvxqsmp->ColorNegMax;
		/*
		float *mapdata = new float[smp->nrOfVertices];
		int i; 
		int cntr = 0;
		for (i=((mapnr - 1) * nrVertices); i<(mapnr * nrVertices); i++) {
		mapdata[cntr] = data[i];
		cntr++;
		}*/

		smpmaps[mapnr].mapData = data;
	}
	smp->srfStatMaps = smpmaps;
	return smp;
}

// for import: create SMP in BVQX, hang in our own structure
bool convertSMP(smpStruct *smp) {

	bool success = true;

	// 0. checks
	SRF_Header *srfbvqx = new SRF_Header;
	int suc6 = qxGetCurrentSRF(srfbvqx);
	if ((suc6 < 1) || (srfbvqx->NrOfVertices != smp->nrOfVertices)) {
		qxMessageBox("The number of vertices of the map is not equal to number of vertices in surface. Process terminated.");
		return false;
	}

	// 1a. create BrainVoyager structure(s)

	// 07-01-2011: add 
	
	
	
	// BrainVoyager specific header
	SMPs_Header *smpmainbvqx = new SMPs_Header;	

	// per map:
	int mapnr;
	for (mapnr=0; mapnr < smp->nrOfMaps; mapnr++) {

		// 1b. Create SMP in BrainVoyager
		suc6 = qxCreateSMPForCurrentSRF();
		SMP_Header *smpbvqx = new SMP_Header; // added 'new' 16-12-10
		float *smpdata = qxGetSMPOfCurrentSRF(mapnr, smpbvqx);

		// 2. Set values in SMP header + data in data
		smpbvqx->MapType = smp->srfStatMaps[mapnr].mapType; 
		strcpy(smpbvqx->NameOfSMP, smp->srfStatMaps[mapnr].surfaceMapName);
		smpbvqx->df1 = smp->srfStatMaps[mapnr].df1;
		smpbvqx->df2 = smp->srfStatMaps[mapnr].df2;
		smpbvqx->TransparentColorFactor = 1.0; // added 16-12-10

		// punt van aandacht: blijft pointer beschikbaar na weggooien eigen structuur?
		smpdata = smp->srfStatMaps[mapnr].mapData;
		
		// 3. Update BrainVoyager
		suc6 = qxSetSMPParametersOfCurrentSRF(mapnr, smpbvqx);

	
	} // end of loop over maps

	qxGetSMPsOfCurrentSRF(smpmainbvqx);
	smp->smpbvqx		= smpmainbvqx;
	smp->flag_bvqxhdr	= true;
	return success;

}

// for export
poiStruct *convertPOI(POIs_Header *bvqxpois, int NrOfMeshVertices) {//, SMP_Header *smpbvqx, float *data, int mapnr){
	
	poiStruct *pois								= new poiStruct;
	poiSubStruct *poi							= new poiSubStruct[bvqxpois->NrOfPOIs];
	
	// get general header stuff
	pois->FileVersion = 2;
	pois->POIsFileName = bvqxpois->POIsFileName;
	pois->FromMeshFile = ""; // is not saved in BVQX POI header structure
	pois->NrOfMeshVertices = NrOfMeshVertices;
	pois->NrOfPOIs = bvqxpois->NrOfPOIs;
	pois->NrOfPOIMTCs = bvqxpois->NrOfPOIMTCs;
	
	for (int i = 0; i < bvqxpois->NrOfPOIs; i++){
		
		POI_Header *bvqxpoi					= new POI_Header;
		int *data = qxGetPOI(i, bvqxpoi);
		poi[i].NrOfVertices = bvqxpoi->NrOfVertices;
		char *poiname = new char[256];
		sprintf(poiname, bvqxpoi->POIName);
		poi[i].POIName = poiname;
		poi[i].ColorOfPOI = bvqxpoi->DisplayColor;
		poi[i].ReferenceVertex = bvqxpoi->ReferenceVertex;
		char *infofilename = new char[256];
		sprintf(infofilename, bvqxpoi->InfoFileName);
		poi[i].InfoFileName = infofilename;
		
		// en nu de data
		poi[i].POIdata = data; // TESTEN!!!
		
	}
	pois->poi = poi;
	return pois;
}

// dit is voor import, kan niet gebruikt worden: bvqx substructs niet beschikbaar
/*
bool convertPOI(poiStruct *poi) { 
	
	POIs_Header *bvqxpoi = new POIs_Header;
	
	// get general header stuff
	strcpy(bvqxpoi->POIsFileName, poi->POIsFileName);
	strcpy(bvqxpoi->FromMeshFile, poi->FromMeshFile); 
	bvqxpoi->NrOfVertices	= poi->NrOfMeshVertices;
	bvqxpois->NrOfPOIs		= poi->NrOfPOIs;
	bvqxpois->NrOfPOIMTCs	= poi->NrOfPOIMTCs;
	
	POI_Header *bvxqpatch	= new POI_Header[poi->NrOfPOIs];
	for (int i = 0; i < poi->NrOfPOIs; i++){
	
		
		qxGetPOI(<#int #>, <#struct POI_Header *#>)
		bvqxpatch[i]->NrOfVertices		= poi->poi[i].NrOfVertices;			   
		strcpy(bvqxpatch[i]->POIName, poi->poi[i].POIName);
		bvqxpatch[i]->DisplayColor		= poi->poi[i].ColorOfPOI;
		bvqxpatch[i]->ReferenceVertex	= poi->poi[i].ReferenceVertex;    // New in BVQX v2.0
		strcpy(bvqxpatch[i]->InfoFileName, poi->poi[i].InfoFileName);
		
	}
	poi->poibvqx = bvqxpatch;
	poi->flag_bvqxhdr = true;
	return pois;
}*/

