#ifndef CONVERTBVQXSTRUCTS_H
#define CONVERTBVQXSTRUCTS_H

#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include <exception>



#include "Plugin_MTC_Header.h"
#include "Plugin_SMP_Header.h"
#include "Plugin_SRF_Header.h"
#include "SRF_Header.h"
#include "MTC_Header.h"
#include "SMP_Header.h"
#include "POI_Header.h"


/*! 
@function convertSRF
@abstract Convert current SRF as retrieved via the plugin SRF_Header to a SRF structure.
*/
srfStruct *convertSRF(SRF_Header *srfbvqx);
/*! 
@function convertMTC
@abstract Convert current MTC as retrieved via the plugin MTC_Header to a MTC structure.
*/
mtcStruct *convertMTC(MTC_Header *mtcbvqx, float **data);

/*! 
@function convertSMP
@abstract Convert current SMP as retrieved via the plugin SMP_Header to an SMP structure.
*/
smpStruct *convertSMP(SMPs_Header *smph);
/*! 
 @function convertPOI
 @abstract Convert current POI as retrieved via the plugin POI_Header to a POI structure.
 */
poiStruct *convertPOI(POIs_Header *bvqxpois, int NrOfMeshVertices);
/*! 
@function convertSMP
@abstract Convert own SMP structure to BrainVoyager plugin SMP_Header structure.
*/
bool convertSRF(srfStruct *srf);
/*! 
@function convertSMP
@abstract Convert own SMP structure to BrainVoyager plugin SMP_Header structure.
*/
bool convertSMP(smpStruct *smp);
/*!
@function convertMTC
@abstract convert own MTC structure to BrainVoyager structure
*/
bool convertMTC(mtcStruct *mtc);
/*
@function convertPOI
@abstract convert own POI structure to BrainVoyager structure
*/
bool convertPOI(poiStruct *poi);




#endif // CONVERTBVQXSTRUCTS_H